{****************************************************************************}
{                                                                            }
{ᮢ ࠡ 㤥 1  㯯 -13 ஭祢 ࣥ ᨫ쥢.}
{                                                                            }
{****************************************************************************}

program Minymisation_on_graf;
uses CRT,Graph,MouseMir,GrafLib;

{$I grinit}
{$I keyclick}

{$L egavga.obj}

type
	Chars=set of Char;

const
	NKeys=9;
	VertRad=3;
	ArcColor:Byte=LightGreen;
	VertColor:Byte=Magenta;
	TreeColor:Byte=White;
	MessColor:Byte=White;
	HelpColor:Byte=LightGreen;
	FileNameContains:Chars=['0'..'9',''''..'z','.','!','_','~'];
	StrWeightContains:Chars=['0'..'9','.'];
	EndProgram:Boolean=False;

var
	Graf:GrafType;
	Flag:array[1..NKeys]of Boolean;
	FileName:String;
	PathTree:NodePtr;
	F:File of GrafType;
	Fvert:File of Vertex;
	Farc:File of Arc;

procedure EGAVGADriverProc;external;

procedure Setup;	{⠭ 梥⮢}
var
	Fconfig:File of Byte;
begin
	Assign(Fconfig,'minygraf.cfg');
	{$I-}Reset(Fconfig);{$I+}
	if IOResult=0 then
		if FileSize(Fconfig)=5 then begin
			Read(Fconfig,ArcColor);
			Read(Fconfig,VertColor);
			Read(Fconfig,TreeColor);
			Read(Fconfig,MessColor);
			Read(Fconfig,HelpColor);
		end;
	if RegisterBGIDriver(@EGAVGADriverProc)<0 then begin
		WriteLn('Including EGAVGA.BGI driver faled.');
		WriteLn('Program halted.');
		Halt(1);
	end;
end;

procedure Intro;	{⠢}
const
	Max=3;
	Mes:array [1..Max] of string[14]=(
		'  ஭祢   ',
		'   ࣥ    ',
		'।⠢:');
var
	i:Byte;
	x1,y1:Word;

	procedure JumpingLetters(Message:string);
	var
		i:Byte;
	begin
		for i:=1 to 5 do begin
			SetTextStyle(0,0,i);
			ClearDevice;
			OutTextXY(x1-50*i,y1,Message);
			Delay(200);
			if KeyPressed then Exit;
		end;
		Delay(300);
		for i:= 63 downto 0 do begin
			SetRGBPalette(EGAWhite,i,i,i);
			Delay(30);
		end;
		ClearDevice;
		SetRGBPalette(EGAWhite,63,63,63);
	end;
begin
	SetBkColor(Black);
	SetColor(White);
	SetRGBPalette(EGAWhite,63,63,63);
	x1:=300; y1:=200;
	for i:=1 to Max do if not KeyPressed then JumpingLetters(Mes[i]);
	SetRGBPalette(EGAWhite,63,63,63);
	ClearDevice;
end;

procedure Design;	{䮬 ࠭}
const
	Title:array[1..NKeys]of string[22]=
	(' 設',
	' ',
	'ᮢ ',
	' ॢ',
	' ',
	'࠭ ',
	'㧨 ',
	'',
	'室');
var
	i:byte;
begin
	SetTextStyle(0,0,1);
	DrawKey(5,5,430,470,3);
	ClickOn(5,5,430,470,3);
	for i:=1 to NKeys do begin
		DrawKey(440,5+(i-1)*30,195,25,2);
		OutTextXY(450,15+(i-1)*30,Title[i]);
	end;
end;

procedure SlidePalette;	{ '' ࠦ}
var
	i:Byte;
begin
	for i:=0 to 63 do begin
		if i<41 then SetRGBPalette(7,i,i,i);
		if i<17 then SetRGBPalette(56,i,i,i);
		SetRGBPalette(63,i,i,i);
	end;
end;

procedure InputString(x,y:Integer;Contains:Chars;Leng:Byte;
	Header,invitation:String;var MyString:String);	{ ப}
var
	Ch:Char;          { .}
	StrCh:String[1];	{  OutText.}
begin
	MyString[0]:=#0;                     {460,320}
	SetColor(LightGreen);
	OutTextXY(x-10,y-35,Header);
	Line(x-12,y-26,x-8+Length(Header)*8,y-26);
	SetColor(LightCyan);
	OutTextXY(x-10,y-20,Invitation);
	while KeyPressed do ReadKey;	{⪠  }
	repeat
		SetColor(LightRed);
		Line(x+Ord(MyString[0])*8,y,x+Ord(MyString[0])*8,y+10);
		repeat until KeyPressed;
		SetColor(GetBkColor);
		Line(X+Ord(MyString[0])*8,y,x+Ord(MyString[0])*8,y+10);
		Ch:=ReadKey;
		if Ch=#13 then exit;
		if (Ch=#8) and (Ord(MyString[0])>0) then begin
			Dec(MyString[0]);
			SetFillStyle(0,GetBkColor);
			Bar(x+Ord(MyString[0])*8,y+2,x+8+Ord(MyString[0])*8,y+10);
		end;
		if Ord(MyString[0])<Leng then
			if Ch in Contains then begin
				StrCh[1]:=Ch;
				SetColor(LightBlue);
				OutTextXY(x+Ord(MyString[0])*8,y+2,StrCh[1]);
				Inc(MyString[0]);
				MyString[Ord(MyString[0])]:=Ch;
			end;
	until False;
end;

procedure AddVertex;	{ 設}
var
	Temp:VertexPtr;

	function InOld:Boolean;	{⥫   । 設?}
	var
		Temp:VertexPtr;
	begin
		Temp:=Graf.ListVertex;
		while Temp<>nil do begin
			if (MouseX>=Temp^.X-(VertRad*2+1))and(MouseX<=Temp^.X+(VertRad*2+1))and
	(MouseY>=Temp^.Y-(VertRad*2+1))and(MouseY<=Temp^.Y+(VertRad*2+1))then begin
				InOld:=True;
				exit;
			end;
			Temp:=Temp^.NextVertex;
		end;
		InOld:=False;
	end;
begin
	SetMouseRange(15,15,425,465);
	SetMouseCoords(220,240);
	MouseShow;
	repeat MouseAsk until MouseKeys=0;
	repeat
		MouseAsk;
		if MouseKeys=1 then
		if not InOld then begin
			Graf.VertNumber:=Graf.VertNumber+1;
			Temp:=Graf.ListVertex;
			if Temp<>nil then begin
				while Temp^.NextVertex<>nil do Temp:=Temp^.NextVertex;
				Temp^.NextVertex:=NewVertex(Graf.VertNumber,nil,nil,MouseX,MouseY);
			end
			else Graf.ListVertex:=NewVertex(Graf.VertNumber,nil,nil,MouseX,MouseY);
			MouseHide;
			SetFillStyle(1,VertColor);
			FillEllipse(MouseX,MouseY,VertRad,VertRad);
			MouseShow;
			repeat MouseAsk until MouseKeys=0;
		end
		else begin
			SetFillStyle(0,GetBkColor);
			Bar(440,290,630,320);
			SetFillStyle(1,GetColor);
			OutTextXY(450,300,'XO-XO-XO: !');
			Sound(500);
			Delay(500);
			NoSound;
		end;
	until MouseKeys=2;
	SetFillStyle(0,GetBkColor);
	Bar(450,300,630,310);
	SetFillStyle(1,GetColor);
	SetMouseRange(0,0,639,479);
end;

procedure AddArc;	{ 㣨}
var
	FirstVertex,SecondVertex:VertexPtr;
	TempArc:ArcPtr;
	StrWeight:String;
	Weight:Real;
	i:Integer;

	function InVertex:VertexPtr;	{⥫   । 設?}
	var
		Temp:VertexPtr;
	begin
		Temp:=Graf.ListVertex;
		while Temp<>nil do begin
			if (MouseX>=Temp^.X-VertRad) and (MouseX<=Temp^.X+VertRad)and
			(MouseY>=Temp^.Y-VertRad) and (MouseY<=Temp^.Y+VertRad) then begin
				InVertex:=Temp;
				exit;
			end;
			Temp:=Temp^.NextVertex;
		end;
		InVertex:=nil
	end;

	function ArcPresent(CurArc:Arcptr;Vert:Byte):Boolean;	{  㣠?}
	begin
		while CurArc<>nil do if CurArc^.Vert=Vert then begin
				ArcPresent:=True;
				Exit;
			end
			else CurArc:=CurArc^.NextArc;
		ArcPresent:=False;
	end;

begin
	SetMouseRange(15,15,425,465);
	SetMouseCoords(220,240);
	MouseShow;
	repeat MouseAsk until MouseKeys=0;
	repeat
		MouseAsk;
		if MouseKeys=1 then begin
			FirstVertex:=InVertex;
			if FirstVertex<>nil then begin
				repeat MouseAsk until MouseKeys=0;
				repeat
					MouseAsk;
					if MouseKeys=1 then begin
						SecondVertex:=InVertex;
						if SecondVertex<>nil then begin
							SetFillStyle(0,GetBkColor);
							Bar(450,300,630,310);
							SetFillStyle(1,GetColor);
							if FirstVertex^.Vert<>SecondVertex^.Vert then
	if not ArcPresent(FirstVertex^.ListArc,SecondVertex^.Vert) then
		begin
			if Graf.UserWeight then repeat	{ '' 㣨...}
				DrawKey(440,275,195,200,2);
				ClickOn(440,275,195,200,2);
				InputString(460,320,StrWeightContains,18,' ',
					' '''' 㣨',StrWeight);
				Val(StrWeight,Weight,i);
				if i<>0 then begin
					SetColor(LightRed);
					OutTextXY(460,380,'  ᫮ !!!');
					repeat until KeyPressed;
					ReadKey;
				end;
				SetFillStyle(0,GetBkColor);
				Bar(440,275,635,475);
			until i=0
			else Weight:=Sqrt(Sqr(1.0*(FirstVertex^.X-SecondVertex^.X))+
			Sqr(1.0*(FirstVertex^.Y-SecondVertex^.Y)));
			TempArc:=FirstVertex^.ListArc;
			if TempArc<>nil then begin
				while TempArc^.NextArc<>nil do TempArc:=TempArc^.NextArc;
				TempArc^.NextArc:=NewArc(SecondVertex^.Vert,Weight,nil);
			end
			else FirstVertex^.ListArc:=NewArc(SecondVertex^.Vert,Weight,nil);
			TempArc:=SecondVertex^.ListArc;
			if TempArc<>nil then begin
				while TempArc^.NextArc<>nil do TempArc:=TempArc^.NextArc;
				TempArc^.NextArc:=NewArc(FirstVertex^.Vert,Weight,nil);
			end
			else SecondVertex^.ListArc:=NewArc(FirstVertex^.Vert,Weight,nil);
			SetColor(ArcColor);
			MouseHide;
			Line(FirstVertex^.X,FirstVertex^.Y,SecondVertex^.X,SecondVertex^.Y);
			MouseShow;
		end
		else begin
			SetFillStyle(0,GetBkColor);
			Bar(450,300,630,310);
			SetColor(MessColor);
			OutTextXY(450,300,'㣠 㦥 !');
			Sound(500);
			Delay(500);
			NoSound;
		end
							else begin
								SetFillStyle(0,GetBkColor);
								Bar(450,300,630,310);
								SetColor(MessColor);
								OutTextXY(450,300,' 몠  ⮦ !');
								Sound(500);
								Delay(500);
								NoSound;
							end;
							repeat MouseAsk until MouseKeys=0;
						end
						else begin
							SetFillStyle(0,GetBkColor);
							Bar(450,300,630,310);
							SetColor(MessColor);
							OutTextXY(450,300,'--: ஬!');
							Sound(500);
							Delay(500);
							NoSound;
						end;
					end;
				until MouseKeys=2;
				repeat MouseAsk until MouseKeys=0;
			end
			else begin
				SetFillStyle(0,GetBkColor);
				Bar(450,300,630,310);
				SetFillStyle(1,GetColor);
				SetColor(MessColor);
				OutTextXY(450,300,'--: ஬!');
				Sound(500);
				Delay(500);
				NoSound;
			end;
		end;
	until MouseKeys=2;
	SetFillStyle(0,GetBkColor);
	Bar(450,300,630,310);
	SetFillStyle(1,GetColor);
	SetMouseRange(0,0,639,479);
end;

procedure ReDrawGraf;	{ᮢ }
	procedure ReDrawVertex(CurVertex:VertexPtr);
		procedure ReDrawArc(CurArc:ArcPtr);
		var
			Temp:VertexPtr;
		begin
			if CurArc<>nil then begin
				if CurArc^.Vert>CurVertex^.Vert then begin
					Temp:=FindVertex(CurArc^.Vert,Graf);
					SetColor(ArcColor);
					Line(CurVertex^.X,CurVertex^.Y,Temp^.X,Temp^.Y);
				end;
				ReDrawArc(CurArc^.NextArc);
			end;
		end;
	begin
		if CurVertex<>nil then begin
			SetColor(White);
			With CurVertex^ do FillEllipse(X,Y,VertRad,VertRad);
			ReDrawArc(CurVertex^.ListArc);
			ReDrawVertex(CurVertex^.NextVertex);
		end;
	end;
begin
	SetFillStyle(0,GetBkColor);
	Bar(10,10,430,470);
	SetFillStyle(1,VertColor);
	SetColor(White);
	MouseHide;
	ReDrawVertex(Graf.ListVertex);
	MouseShow;
end;

procedure NewGraf;	{ }
var
	Ch:Char;
begin
	SetFillStyle(0,GetBkColor);
	Bar(10,10,430,470);
	DisposeGraf(Graf.ListVertex);
	Graf.ListVertex:=nil;
	Graf.VertNumber:=0;
	DrawKey(440,275,195,200,2);
	ClickOn(440,275,195,200,2);
	SetColor(LightGreen);
	OutTextXY(450,290,'   ?');
	OutTextXY(450,305,'/ Y  N.../');
	SetColor(Red);
	repeat
		repeat until KeyPressed;
		Ch:=ReadKey;
		if (Ch='Y') or (Ch='y') then Graf.UserWeight:=True
			else if (Ch='N') or (Ch='n') then Graf.UserWeight:=False
				else begin
					OutTextXY(450,350,'㪨 , ???');
					OutTextXY(450,370,' Y  N !!!');
				end;
	until (Ch='Y') or (Ch='y') or (Ch='N') or (Ch='n');
	SetFillStyle(0,GetBkColor);
	Bar(440,275,635,475);
end;

procedure ShowPathTree;	{ ॢ 砩 ⥩}
var
	RootVertex:VertexPtr;

	function InVertex:VertexPtr;
	var
		Temp:VertexPtr;
	begin
		Temp:=Graf.ListVertex;
		while Temp<>nil do begin
			if (MouseX>=Temp^.X-VertRad) and (MouseX<=Temp^.X+VertRad)and
			(MouseY>=Temp^.Y-VertRad) and (MouseY<=Temp^.Y+VertRad) then begin
				InVertex:=Temp;
				exit;
			end;
			Temp:=Temp^.NextVertex;
		end;
		InVertex:=nil
	end;

	procedure DrawPathTree(CurNode:NodePtr);	{ᮢ 砩 ⥩}
	var
		TempNode:NodePtr;
		FirstVertex:VertexPtr;
		SecondVertex:VertexPtr;
	begin
		FirstVertex:=FindVertex(CurNode^.Vert,Graf);
		TempNode:=CurNode^.NextLevel;
		while TempNode<>nil do begin
			SecondVertex:=FindVertex(TempNode^.Vert,Graf);
			SetColor(TreeColor);
			MouseHide;
			Line(FirstVertex^.X,FirstVertex^.Y,SecondVertex^.X,SecondVertex^.Y);
			MouseShow;
			DrawPathTree(TempNode);
			TempNode:=TempNode^.NextNode;
		end;
	end;{DrawPathTree}

begin
	SetMouseRange(15,15,425,465);
	SetMouseCoords(220,240);
	RootVertex:=nil;
	MouseShow;
	repeat MouseAsk until MouseKeys=0;
	repeat
		MouseAsk;
		if MouseKeys=1 then begin
			SetFillStyle(0,GetBkColor);
			Bar(450,300,630,310);
			SetFillStyle(1,GetColor);
			RootVertex:=InVertex;
			if RootVertex<>nil then break
			else begin
				SetFillStyle(0,GetBkColor);
				Bar(450,300,630,310);
				SetColor(MessColor);
				OutTextXY(450,300,'--: ஬!');
				Sound(500);
				Delay(500);
				NoSound;
			end;
		end;
	until MouseKeys=2 ;
	SetFillStyle(0,GetBkColor);
	Bar(450,300,630,310);
	SetFillStyle(1,GetColor);
	if RootVertex<>nil then begin
		MakePathTree(Graf,RootVertex^.Vert,PathTree);{ ॢ !!!}
		DrawPathTree(PathTree);								{ᮢ  !!!}
		DisposePathTree(PathTree);							{ 㤠.}
	end;
	SetMouseRange(0,0,639,479);
end;

procedure OnIOErrorMessage(i:Integer);	{饭  訡 /}
var
	S:String;
begin
	case i of
		2:S:='  ';
		4:S:='  䠩';
		else begin
			Str(i,S);
			S:='訡 / # '+S;
		end;
	end;
	SetColor(MessColor);
	OutTextXY(460,360,S);
	repeat until KeyPressed;
	ReadKey;
end;

procedure EndDiskOperation;	{⪠  &  䠩}
var
	Fuflo:Boolean;
begin
	{$I-}Fuflo:=Eof(F);{$I+}
	if IOResult=0 then Close(F);
	{$I-}Fuflo:=Eof(Fvert);{$I+}
	if IOResult=0 then Close(Fvert);
	{$I-}Fuflo:=Eof(Farc);{$I+}
	if IOResult=0 then Close(Farc);
	SetFillStyle(0,GetBkColor);
	Bar(440,275,635,475);
end;

procedure SaveGraf;	{࠭ }
var
	i:Integer;
	s:String;
	procedure SaveVertex(CurVertex:VertexPtr);
		procedure SaveArc(CurArc:ArcPtr);
		begin
			if CurArc<>nil then begin
				Write(Farc,CurArc^);
				SaveArc(CurArc^.NextArc);
			end;
		end;
	begin
		if CurVertex<>nil then begin
			Write(Fvert,CurVertex^);
			SaveArc(CurVertex^.ListArc);
			SaveVertex(CurVertex^.NextVertex);
		end;
	end;

begin
	DrawKey(440,275,195,200,2);
	ClickOn(440,275,195,200,2);
	InputString(460,320,FileNameContains,8,'   ',
		'  䠩:',FileName);
	if FileName<>'' then begin
		Assign(F,FileName+'.grf');
		Assign(Fvert,FileName+'.vrt');
		Assign(Farc,FileName+'.arc');
		{$I-} Rewrite(F); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		{$I-} Rewrite(Fvert); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		{$I-} Rewrite(FArc); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		Write(F,Graf);
		SaveVertex(Graf.ListVertex);
	end;
	EndDiskOperation;
end;


procedure LoadGraf;	{㧪 }
var
	i:Integer;
	s:String;
	procedure LoadVertex(var CurVertex:VertexPtr);
		procedure LoadArc(var CurArc:ArcPtr);
		begin
			New(CurArc);
			Read(Farc,CurArc^);
			if CurArc^.NextArc<>nil then LoadArc(CurArc^.NextArc);
		end;
	begin
		New(CurVertex);
		Read(Fvert,CurVertex^);
		if CurVertex^.ListArc<>nil then LoadArc(CurVertex^.ListArc);
		if CurVertex^.NextVertex<>nil then LoadVertex(CurVertex^.NextVertex);
	end;

begin
	DrawKey(440,275,195,200,2);
	ClickOn(440,275,195,200,2);
	InputString(460,320,FileNameContains,8,'   ',
		'  䠩:',FileName);
	if FileName<>'' then begin
		Assign(F,FileName+'.grf');
		Assign(Fvert,FileName+'.vrt');
		Assign(Farc,FileName+'.arc');
		{$I-} Reset(F); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		{$I-} Reset(Fvert); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		{$I-} Reset(FArc); {$I+}
		i:=IOResult;
		if i<>0 then begin	{訡 !!!}
			OnIOErrorMessage(i);
			EndDiskOperation;
			Exit;
		end;
		Read(F,Graf);
		if Graf.ListVertex<>nil then LoadVertex(Graf.ListVertex);
		ReDrawGraf;
	end;
	EndDiskOperation;
end;

procedure Help;	{}
type
	HelpString=String[50];
	HelpRecordPtr=^HelpRecord;
	HelpRecord=record
		HelpStr:HelpString;
		Last,Next:HelpRecordPtr;
	end;

const
	SubTitle:array[1..3]of string[20]=
		('। ࠭',
		' ࠭',
		'室  ');
var
	FHelp:Text;
	HelpRec:HelpRecordPtr;
	Temp:HelpRecordPtr;
	OldHelpRec:HelpRecordPtr;
	i,j:Integer;
	EndHelp:Boolean;

	procedure ShowPage;	{ ࠭   ࠭}
	var
		k:Byte;
	begin
		OldHelpRec:=HelpRec;
		k:=0;
		SetColor(HelpColor);
		while (k<>40) and (HelpRec<>nil) do begin
			OutTextXY(20,60+k*10,HelpRec^.HelpStr);
			HelpRec:=HelpRec^.Next;
			inc(k);
		end;
		if HelpRec=nil then
			OutTextXY(110,460,'***  䠩  ***');
		HelpRec:=OldHelpRec;
	end;{ShowPage}
begin
	Assign(FHelp,'minygraf.hlp');
	ReSet(FHelp);
	SetFillStyle(0,GetBkColor);
	Bar(10,10,430,470);
	SetColor(LightBlue);
	SetTextStyle(0,0,4);
	OutTextXY(85,20,'MINY-GRAF');
	SetColor(Red);
	SetTextStyle(0,0,0);
	OutTextXY(510,285,'');
	DrawKey(440,275,195,200,2);
	ClickOn(440,275,195,200,2);
	SetMouseRange(445,280,630,470);
	for j:=1 to 3 do begin
		DrawKey(450,295+(j-1)*30,175,25,2);
		OutTextXY(460,305+(j-1)*30,SubTitle[j]);
	end;
	New(HelpRec);
	with HelpRec^ do begin
		Last:=nil;
		Next:=nil;
		ReadLn(FHelp,HelpStr);
	end;
	while not EOF(FHelp) do begin
		New(Temp);
		ReadLn(FHelp,Temp^.HelpStr);
		HelpRec^.Next:=Temp;
		Temp^.Last:=HelpRec;
		HelpRec:=Temp;
	end;
	HelpRec^.Next:=nil;
	while HelpRec^.Last<>nil do HelpRec:=HelpRec^.Last;
	ShowPage;
	MouseShow;
	EndHelp:=False;
	repeat
		MouseAsk;
		if MouseKeys=1 then
			for j:=1 to 3 do if (MouseX>450) and (MouseX<625)
				and (MouseY>295+(j-1)*30) and (MouseY<315+(j-1)*30)then begin
					case j of
						1:begin
								i:=0;
								while (i<40) and (HelpRec^.Last<>nil)do begin
									i:=i+1;
									HelpRec:=HelpRec^.Last;
								end;
								if i<40 then HelpRec:=OldHelpRec
								else begin
									MouseHide;
									ClickOn(450,295+(j-1)*30,175,25,2);
									SetFillStyle(0,GetBkColor);
									Bar(10,60,430,470);
									ShowPage;
									ClickOff(450,295+(j-1)*30,175,25,2);
									MouseShow;
								end;
							end;
						2:begin
								OldHelpRec:=HelpRec;
								i:=0;
								while (i<40) and (HelpRec^.Next<>nil)do begin
									i:=i+1;
									HelpRec:=HelpRec^.Next;
								end;
								if i<40 then HelpRec:=OldHelpRec
								else begin
									MouseHide;
									ClickOn(450,295+(j-1)*30,175,25,2);
									SetFillStyle(0,GetBkColor);
									Bar(10,60,430,470);
									ShowPage;
									ClickOff(450,295+(j-1)*30,175,25,2);
									MouseShow;
								end;
							end;
						3:EndHelp:=True;
					end;
				end;
	until EndHelp;
	MouseHide;
	SetFillStyle(0,GetBkColor);
	Bar(10,60,430,470);
	Bar(440,275,635,475);
	SetMouseRange(0,0,639,479);
	ReDrawGraf;
	MouseShow;
	Close(FHelp);
end;

procedure Quit;	{⠭ 䫠 室}
begin
	EndProgram:=True;
end;

function InRange(i:Byte):Boolean;
begin
	InRange:=(MouseX>=440)and(MouseX<=635)
	and(MouseY>=5+(i-1)*30)and(MouseY<=30+(i-1)*30);
end;

procedure ClkOn;	{஢ઠ 롮 㭪 }
var
	i:Byte;
begin
	for i:=1 to NKeys do
		if (InRange(i)) and (not Flag[i]) and (MouseKeys=1) then begin
			Flag[i]:=True;
			MouseHide;
			ClickOn(440,5+(i-1)*30,195,25,2);
			{맮 楤!!!!!!!!!!!!!!!!!!!!::::::::::::::}
			case i of
				1: AddVertex;
				2: AddArc;
				3: ReDrawGraf;
				4: ShowPathTree;
				5: NewGraf;
				6: SaveGraf;
				7: LoadGraf;
				8: Help;
				9: Quit;
			end;
			MouseShow;
		end;
end;

procedure ClkOff;	{'⦠⨥' }
var
	i:Byte;
begin
	for i:=1 to NKeys do
		if (Flag[i]) and ((not InRange(i))or(MouseKeys<>1)) then begin
			Flag[i]:=False;
			MouseHide;
			ClickOff(440,5+(i-1)*30,195,25,2);
			MouseShow;
		end;
end;

procedure ClickCheck;	{஢ઠ    }
const
	Flag:Boolean=False;
begin
	MouseShow;
	repeat
		MouseAsk;
		ClkOn;
		ClkOff;
	until EndProgram;
	MouseHide;
end;

procedure Copyrights;	{   ⠪ ⭮}
begin
	WriteLn;
	WriteLn('Thank you for using MYNY-GRAF.');
	WriteLn('This is SHAREWARE version.');
	WriteLn('You may registed it for only $10 !!!');
	WriteLn;
	WriteLn('Adress to contact:');
	WriteLn('     Russia Federation,');
	WriteLn('     Moscow area,');
	WriteLn('     Pushkino,');
	WriteLn('     2nd Nekrasovskiy st.,5/142,');
	WriteLn('     Mironchev Sergey Vasylevich.');
end;

BEGIN
	Setup;
	if GrInit <> 0 then Halt(1);
	Intro;
	SetRGBPalette(7,0,0,0);
	SetRGBPalette(56,0,0,0);
	SetRGBPalette(63,0,0,0);
	SetBkColor(7);
	Design;
	SlidePalette;
	MouseReset;
	SetMouseRange(0,0,639,479);
	with Graf do begin
		ListVertex:=nil;
		VertNumber:=0;
		UserWeight:=False;
	end;
	while KeyPressed do ReadKey;
	ClickCheck;
	CloseGraph;
	Copyrights;
END.